#include <iostream>
#include "util/cuda_system.h"
#include "util/matrices.h"
#include "nmf/single_dense_mu_nmf1.h"

int main() {
    // If I set the environment variables CUDA_VISIBLE_DEVICES=1,3, the devices will have
    // indexes 0, 1.
    // CudaSystem::printDevicesInfo();

    // MeMatrix F1 = random_matrix(640, 16);
    // MeMatrix F2 = random_matrix(16, 1280);

    // MeMatrix A = MeMatrix::multiply(F1, F2);
    // MeMatrix A = random_matrix(64, 128);
    // MeMatrix A = random_matrix(8000, 12000);
    MeMatrix A = random_matrix(8000, 80000);

    std::cout << "Made matrix, starting NMF.\n";

    long rank = 32;
    long seed = 4319043202;
    float eps = 1e-9;
    float tol = 1e-6;
    // float eps = 1e-6;
    // int max_iters = 10000;
    // int max_iters = 8;
    int max_iters = 1000;

    MuNmf nmf(&A, rank, max_iters, eps, tol, seed);
    nmf.run();

    return 0;
}