#include <iostream>
#include "util/cuda_system.h"
#include "util/matrices.h"
// #include "nmf/sparse/single_mu_dense_factors_nmf1.h"
#include "nmf/sparse/single_mu_dense_factors_nmf2.h"

int main() {
    long inputMatSeed = 98138924323;
    // float density = 0.0001f;
    float density = 0.01f;

    // int n_rows = 8000;
    // // int n_cols = 120000;
    // int n_cols = 80000;

    // int n_rows = 800;
    // int n_cols = 1200;

    int n_rows = 8000;
    int n_cols = 12000;

    ElCsrMatrix A = random_csr_matrix(n_rows, n_cols, density, inputMatSeed);

    std::cout << "A.nnz = " << A.nnz << "\n";

    std::cout << "Made matrix, starting NMF.\n";

    long rank = 1024;
    // long rank = 32;

    long seed = 4319043202;
    float eps = 1e-9;
    // float eps = 1e-6;
    // int max_iters = 10000;
    int max_iters = 8;
    // int max_iters = 1000;

    MuNmf nmf(&A, rank, max_iters, eps, seed);
    nmf.run();

    return 0;
}
